
(function (scope) {
    function App() {
        this.initialize();
    }

    //variables de objetos
    var canvas = App.prototype, stage = App.prototype, cargador = App.prototype,hero = App.prototype,
        nube1 = App.prototype, nube2 = App.prototype, suelo = App.prototype, fondo = App.prototype, fondo2 = App.prototype;

    // variables generales
    var ancho=0, alto=0, accel=4, punts=0, X1=0, X2=0, colision=null, colisionables=[], limit = 440, auxi = null, cont=0;

    //semaforos
    var stop1 = false, stop2=false, ensuelo = false, saltox2 = false, stopLimit = false, col = [];


	//Rutas imagenes
	var	rhero   = "images/hero.png",
        rnube1  = "images/nube1.png",
        rnube2  = "images/nube2.png",
        rsuelo  = "images/suelo.png",
        rsuelo2 = "images/suelo200.png",
        rsuelo3 = "images/suelo300.png",
		rfondo  = "images/fondo.png";


    // funcion inicio
    App.prototype.initialize = function () {
        var self = this;

        //creamos el objeto canvas
        canvas = document.createElement('canvas');
        canvas.width = 800;
        canvas.height = 600;
        var joc = document.getElementById('joc');
        joc.appendChild(canvas);

        ancho = canvas.width;
        alto = canvas.height;

        //inicializamos el stage
        stage = new createjs.Stage(canvas);

        //carga de imagenes
        cargador = new Cargador();
        cargador.onComplete = function () {
            self.imgCargadas();
        };
        cargador.loadImagenes([rhero, rnube1, rnube2, rsuelo,rsuelo2,rsuelo3, rfondo]);

      
       
        
    };

     App.prototype.imgCargadas = function () {
        //console.log(cargador);//imagenes cargadas
       
        var self = this;
       
       //FONDOS
        fondo = new createjs.Bitmap(cargador[rfondo]);
        fondo.name = "Fondo";
        fondo.snapToPixel = true;

        fondo2 = new createjs.Bitmap(cargador[rfondo]);
        fondo2.name = "Fondo2";
        fondo2.snapToPixel = true;
        fondo2.setTransform(1066,0);

        stage.addChild(fondo,fondo2);

        //NUBES
        nube1 = new createjs.Bitmap(cargador[rnube1]);
        nube1.alpha = 0.8;
        nube1.setTransform(ancho,300);
       
        nube2 = new createjs.Bitmap(cargador[rnube2]);
        nube2.alpha = 0.8;
        nube2.setTransform(ancho,150);

        stage.addChild(nube2,nube1);

        //SUELOS
        for( i=0; i<6 ;i++){
            var tsu = [rsuelo2,rsuelo3];
            suelo[i] = new createjs.Bitmap(cargador[tsu[Math.floor(Math.random()*2)]]);
            var su = suelo[i].getBounds();
            var alt = Math.random() > 0.5 ? alto-su.height-30 : alto-su.height;
            if(i==0){
                alt=alto-su.height-30;
            }
            suelo[i].setTransform(ancho+i*450+50*Math.random(), alt); 
            suelo[i].name = "suelo"+i;
            stage.addChildAt(suelo[i],stage.numChildren-i);
            colisionables.push(suelo[i]); //añadimos los suelos a las colisiones;
        }
        
        // console.log(suelo);
        // console.log(colisionables);

        //HEROE  

        var spriteSheet = new createjs.SpriteSheet({
            framerate: 20,
            "images": [cargador[rhero]],
            "frames": {"height": 58, "width": 42},
            // define two animations, run (loops, 1.5x speed):
            "animations": {
                "run":[0,2],
                "stand":[0] 
                
            }
        });

        hero = new createjs.Sprite(spriteSheet, "stand");
        hero.velocity = {x:0, y:10};
        //hero.y = 440;
        hero.x = 200;

        stage.addChild(hero);
        //console.log(hero);

        // ANIMACIONES
       
        createjs.Ticker.setFPS(20);
        createjs.Ticker.on("tick", function (e) {
           

            hero.y += hero.velocity.y;

            for(i=0; i<colisionables.length; i++){
                var baux = colisionables[i].getBounds();
                var colbound = {"x":colisionables[i].x, "y":colisionables[i].y, "width":baux.width, "height":baux.height };    

                if(colbound.x > -1 && colbound.x < 601) {
                    colision = detectaColision(limit,hero,colisionables[i]);  
               
                    var condicion = colbound.x+colbound.width;
                    if(condicion >= hero.x   ){
                        col[i] = true;
                        //console.log(col,colbound.x);                    
                    }
                
                } 

            }
            
            self.calculaSuelo(hero,colision);
           
           
            if(ensuelo && hero.currentAnimation != "run"){
                hero.gotoAndPlay("run");
            }
                
            var random = Math.random(), bounds1 = nube1.getBounds(), bounds2 = nube2.getBounds();
            
            if(stop1 == false && stop2 == false){
                X1 = Math.floor(Math.random()*5)+1,
                X2 = Math.floor(Math.random()*5)+1;         
                stop1 = true;
                stop2 = true;
            }

            nube1.x -= X1 + accel;
            nube2.x -= X2 + accel;
            //console.log('nube1: '+nube1.x, 'nube2: '+nube2.x);
            
            if(nube1.x < - bounds1.width){
               nube1.x = ancho + (ancho/2)*random;
               nube1.y = random > 0.5 ? (random * 300) : (random * 150 + bounds1.height);
               stop1 = false
               
              // console.log('Alto nube1: '+ nube1.y);
            }

            
            if(nube2.x < - bounds2.width ){
               nube2.x = ancho + (ancho/2)*random;
               nube2.y = random > 0.5 ? (random * 150) : (random * 300 + bounds2.height);
               stop2 = false;

               //console.log('Alto nube2: '+ nube2.y);
            }


            for(i=0; i< 6; i++){
                suelo[i].x -= 1 + accel;
                var su = suelo[i].getBounds();
                if(suelo[i].x < - su.width){
                    var aux = colisionables[suelo[i]];
                    
                    // creando desniveles
                    var alt = Math.random() > 0.5 ? alto-su.height-30 : alto-su.height;
                    if(i==0 || up == 0){
                        alt=alto-su.height-30;
                        up = 2;
                    }
                    if(alt == alto-su.height-30){ up ++ ; }else{ up-- ; }

                    var dista = ancho-su.width+ 5*450 + Math.random()*50; // 5 -> numero de suelos
                    
                    suelo[i].setTransform(dista, alt);   
                  // console.log(i+": "+suelo[i].x);
                   
                    stage.addChildAt(suelo[i],stage.numChildren); // colocamos penultimo para que tape todo lo de detras
                    stage.addChildAt(hero,stage.numChildren); // el heroe siempre tiene que estar el ultimo
                    colisionables[aux] = suelo[i];//actualizamos los parametros de colision
                        
                    
                //  console.log( suelo[0].y, suelo[1].y, suelo[2].y);
                //  console.log(colisionables[0].y,colisionables[1].y,colisionables[2].y);
                }
              
            }
            
             
            fondo.x  -= 1 + accel;
            fondo2.x -= 1 + accel;

            if (fondo.x < -1066) fondo.x = 0;
            if (fondo2.x < 0) fondo2.x = 1066; //vamos alternando los fondos

            punts += 0.5;

            if( punts % 100 == 0){
                accel ++;
                createjs.Ticker.setFPS(20 + Math.floor(accel/10));
            
            } // Incrementamos velocidad cada 100 puntos;
            
            


            $("#puntuacion").html(Math.floor(punts));

            stage.update();
        });

    };

    App.prototype.saltar = function () {
        if ( ensuelo ) {  // si esta en el suelo puede saltar
            hero.velocity.y = -10; 
            ensuelo = false;
            saltox2 = true;
        
        } else if ( saltox2 ) { // si esta en el aire puede hacer un segundo salto
            hero.velocity.y = -10;
            saltox2 = false;
        }
    };

    
    App.prototype.calculaSuelo = function(hero,colision){


        if( hero.y < limit ){
            hero.velocity.y += 1;
            ensuelo = false;

        } else {
            hero.velocity.y = 0;
            ensuelo = true;
            hero.y = hero.y > limit ? limit : hero.y; // nos aseguramos que no atraviesa el limite en el eje y

        }

       
        if(colision){
           //console.log("c: "+colision.x, "s0: "+suelo[0].x, "s1: "+suelo[1].x);
           if(colision.x > -10 && hero.y > 411){
                $("#punts").html(Math.floor(punts));
                $("#fin").toggle();
                publicarPuntos(Math.floor(punts));
                createjs.Ticker.removeAllEventListeners();
               
               //console.log("Ha chocado, resetear juego"); 
            }

            if(colision.x > -10){ // heroe cerca del desnivel
              limit = 410;
              stopLimit = true;
              auxi = colisionables.indexOf(colision.t);
            }else{
               console.log("Ha chocado!!"); // no deberia darse esta opcion
                $("#punts").html(Math.floor(punts));
                $("#fin").toggle();
                createjs.Ticker.removeAllEventListeners();
               
            }

        }else { 
            if(stopLimit){
                
                cont = detectaColision(440,hero,colisionables[auxi]);
                if( cont.x < (colisionables[auxi].getBounds().width-10) || col[auxi]){
                    limit = 410; 
                    col[auxi] = false;
               }else{
                    limit = 440;
               }

            }else{
                stopLimit = false;
                col[auxi] = false;
                
            }
        }              
        
    };


   
   
    scope.App = App;

}(window));

window.onload = function () {
    app = new App();
    $("#imguser").toggle();
};


function detectaColision(limit,hero,target){

  // calculamos el punto en el que empieza la primera colision
  // consideramos colisión cuando el heroe atraviesa el objeto 
  // es decir, la altura del objeto es mayor y pt.x es positivo
  
  var pc = hero.localToLocal(0,limit,target);

 
  if(hero.y < pc.y && pc.x > -10 ){
    return {"x": pc.x ,"y":pc.y, "t":target};
  }
  
  return false;

}

